#include<stdio.h>
#include<stdlib.h>
#include <iostream>
#include <cstdlib>
#include <time.h>
#include <math.h>

void main()
{
int curindex,id,tempindex,maxindex,constdensity,gdchoice, reverb;
float j,mingraindur,maxgraindur, dur, gphase, start, temp,i,streams,rang,initrang,initgdur,iduration;
float midpointcount1, midpointcount2,midpointcount3,temp2,gfilepos;
float midpointgdur1, midpointgcount1,midpointgdur2, midpointgcount2,midpointgdur3, midpointgcount3;
float a[20000],e[20000],d[20000], igstart,igmid1, igmid2, igmid3, igend,timecount;
float gdstart,gdmid1, gdmid2, gdmid3, gdend,tempmingdur, prevrang;
float index,aval,eval,dval,avalold,evalold,dvalold,offset,gdur,gspeed;
char filenameA[25],filenameE[25],filenameD[25],filename[100],enter;

FILE *ofp;
FILE *ifpa;
FILE *ifpe;
FILE *ifpd;

/******************** WELCOME TEXT *********************************************************/
printf("This program produces a score file for the Csound instrument, \nAmbiBoidgranule.orc\n\n");
printf("Please ensure the coordinates files are stored in the default \nfolder, D:\\Boids\n\n\n");

printf("This instrument granulates a mono sound file into multiple grain streams.\n");
printf("The grain duration and density are dynamically controllable.\n");
printf("In addition, each grain stream is spatialized using the MAX MSP \nimplementation of Boids\n\n");
/********************* OBTAIN USER DATA ****************************************************/ 
printf("1. Grain duration randomly chosen between a given maximum and mimimum.\n");
printf("2. Single grain duration for all streams, dynamically varying.\n"); 
printf("3. Single grain duration for all streams, fixed value.\n");
printf("Please type 1, 2 or 3 and hit return.....");
scanf("%d",&gdchoice);
if(gdchoice==1)
{ 
	printf("Please enter the min grain duration in seconds\n");
	scanf("%f", &mingraindur);
	printf("Please enter the max grain duration in seconds\n");
	scanf("%f", &maxgraindur);
}
if(gdchoice==2)
{ 
	printf("Enter the initial grain duration in seconds\n");
	scanf("%f", &gdstart);
	printf("Enter the grain duration at a 1/4 of the total duration.\n");
	scanf("%f", &gdmid1);
	printf("Enter the grain duration at the 1/2 of the total duration.\n");
	scanf("%f", &gdmid2);
	printf("Enter the grain duration at the 3/4 of the total duration.\n");
	scanf("%f", &gdmid3);
	scanf("%c", &enter);
	printf("Enter the grain duration at the end of the file.\n");
	scanf("%f", &gdend);
	if(gdstart>=gdmid1){tempmingdur=gdmid1;}			//Find the minimum grain duration 
	else{tempmingdur=gdstart;}
	if(gdmid2<tempmingdur){mingraindur=gdmid2;
						   tempmingdur=gdmid2;		}
	if(gdmid3<tempmingdur){mingraindur=gdmid3;
						   tempmingdur=gdmid3;		}	
	if(gdend<tempmingdur) {mingraindur=gdend;
						   tempmingdur=gdend;		}
	else{mingraindur=tempmingdur;				}
	printf("min grain dur is %f\n\n", mingraindur);
}
if(gdchoice==3)
{
	printf("Enter the grain duration in seconds\n");
	scanf("%f", &gdstart);
	mingraindur=gdstart;
}

printf("Type 1 for a constant density or 0 to specify a dynamic density control\n");
scanf("%d", &constdensity);
printf("The intergrain duration is specified in multiples of the grain duration\n");
printf("0 = max. density, 1 = one grain duration of silence between each grain\n");
if(constdensity ==0)
{
	printf("Enter the initial intergrain value\n");
	scanf("%f", &igstart);
	printf("Enter the intergrain value at a 1/4 of the total duration.\n");
	scanf("%f", &igmid1);
	printf("Enter the intergrain value at the 1/2 of the total duration.\n");
	scanf("%f", &igmid2);
	printf("Enter the intergrain value at the 3/4 of the total duration.\n");
	scanf("%f", &igmid3);
	printf("Enter the intergrain value at the end of the file.\n");
	scanf("%f", &igend);
}
else
{
	printf("Enter the intergrain value\n");
	scanf("%f", &igstart);
}

printf("Please enter the total duration in seconds\n");
scanf("%f", &dur);
printf("Please enter the total no of grain streams\n");
scanf("%f", &streams);
printf("Ensure that the spatial sampling interval in MAX MSP\n");
printf("equals the minimum grain duration \n\n");
printf("Type 1 to turn on global reverb, type 0 to turn it off\n");
scanf("%d", &reverb);
scanf("%c",&enter);
printf("Enter the filename to be granulated. Eg. myfile.wav\n");
gets(filename);
printf("Please enter the grain playback speed (1=normal, 0.5=half speed, 2=double speed, etc\n");
scanf("%f", &gspeed);
scanf("%c",&enter);

/********* CREATE FILE AND WRITE GEN ROUTINES **********************************************/
ofp = fopen("AMBIBOIDgranule.sco", "w");  //write user data as comment in score file..
fprintf(ofp, "f1 0 4194304 1 \"%s\" 0 4 1\n",filename);
fprintf(ofp, "f2 0 16385 20 7 1 2    ; grain envelope\n");
fprintf(ofp, "\n;inst\t srt\t\t  dur\t\t voice Phase\t Aziold\t Azi\t\t Elevold\t Elev\t\t Distold\t Dist\t\t Graindur\t File Play Pos\t Play Speed\n");

for(i=1;i<=streams;i++) //loop through each grain stream
{
id=int(i);
printf("writing voice %d \n",id); 
sprintf(filenameA, "D:\\Max\\bg\\bg%da.txt", id);   //create paths and filenames for this stream
sprintf(filenameE, "D:\\Max\\bg\\bg%de.txt", id);
sprintf(filenameD, "D:\\Max\\bg\\bg%dd.txt", id);

ifpa=fopen(filenameA, "r");
ifpe=fopen(filenameE, "r");
ifpd=fopen(filenameD, "r");

if ((ifpa==0) || (ifpe ==0) || (ifpd==0))
{
	printf("Program quitting due to missing Boids input files!\n"); 
	printf("Please ensure the coordinates files are stored in the default \nfolder, D:\\Boids\n\n\n");
	break;
}

for(curindex=0;curindex<20000;curindex++)
 {  // read all the spatal values for this stream into 3 arrays)
    fscanf(ifpa, "%f", &a[curindex]);
	fscanf(ifpe, "%f", &e[curindex]);
	fscanf(ifpd, "%f", &d[curindex]);
	if (feof(ifpd))    /* check End of File flag */
    {
		maxindex=curindex;    
		break; 
	}
 }

index=0;
curindex=0.0;
timecount=0;
temp=rand();
gphase=temp/32767.0;		   //create a random number between 0 and 1
start=0;

if(gdchoice==1)
{ 
	gdur= (mingraindur+(gphase*(maxgraindur-mingraindur)));
}
if((gdchoice==2)||(gdchoice==3))
{ 			
	gdur = gdstart;
}

rang = gdur+(igstart*gdur);	   //calulate total grain duration
initrang = gdur+(igstart*gdur);
initgdur = gdur;
prevrang=rang;
for(j=0.0;j<dur;j=j+rang)	   //each grain	corresponds to a single I statement in the score
 {
  curindex=index;			   //interpolation between regularly sampled spatial co-ordinates
  tempindex=curindex+1;		
  offset=index-curindex;	   	
 if(curindex>=maxindex)
 {
		printf("\n\nEnd of Boids input file reached\n\n");
		printf("Score file will contain unstable values\n\n");
		printf("Please either increase the minimum grain duration, or\n");
		printf("resample Boids in MAX MSP at a faster sampling period\n");
		break;
 }

 aval = (((a[tempindex])-(a[curindex])) * (offset)) + a[curindex]; //interpolate
 eval = (((e[tempindex])-(e[curindex])) * (offset)) + e[curindex]; //interpolate
 dval = (((d[tempindex])-(d[curindex])) * (offset)) + d[curindex]; //interpolate
 aval=aval+360.0;				//ensure azimuth always positive.
 if(j==0)
	{//if reading the very first value then set old value equal to current
	avalold=aval;
	evalold=eval;
	dvalold=dval;
	}
 
 //dynamic grain duration control
 if((timecount<=(dur/4)) && (gdchoice==2))  
	{ 
	 gdur = initgdur+((timecount/(dur/4)) * (gdmid1-gdstart));
	 midpointgdur1=gdur;
	 midpointgcount1=timecount;
	}
 if((timecount>(dur/4)) && (timecount<=(dur/2)) && (gdchoice==2))  
	{ 
	 gdur = midpointgdur1 + (((timecount-midpointgcount1)/(dur/4)) * (gdmid2-gdmid1));
	 midpointgdur2=gdur;
	 midpointgcount2=timecount;
	}
 if((timecount>(dur/2)) && (timecount<=((dur*3)/4)) && (gdchoice==2))  
	{ 
	 gdur = midpointgdur2 + (((timecount-midpointgcount2)/(dur/4)) * (gdmid3-gdmid2));
	 midpointgdur3=gdur;
	 midpointgcount3=timecount;
	}
 if((timecount>((dur*3)/4))&&(gdchoice==2))		
	{
	 gdur = midpointgdur3 + (((timecount-midpointgcount3)/(dur/4))*(gdend-gdmid3));
	}  

//dynamic density control 
 if((timecount<=(dur/4)) && (constdensity==0))  //for start to mid point
	{ 
	  rang = gdur+(igstart*gdur);
	  rang = rang+(gdur*((timecount/(dur/4))*(igmid1-igstart)));   //alter rang (=grain duration + gap)								
	  midpointcount1=timecount;	
	}
 if((timecount>(dur/4)) && (timecount<=(dur/2)) && (constdensity==0))  //for start to mid point
	{ 
	  rang = gdur+(igmid1*gdur);
	  rang = rang+((gdur*(((timecount-midpointcount1)/(dur/4))*(igmid2-igmid1))))/*dirflag*/;   //alter rang (=grain duration + gap)							
	  midpointcount2=timecount;	
	}
 if((timecount>(dur/2)) && (timecount<=((dur*3)/4)) && (constdensity==0))  //for start to mid point
	{ 
	  rang = gdur+(igmid2*gdur);
	  rang = rang+((gdur*(((timecount-midpointcount2)/(dur/4))*(igmid3-igmid2))))/*dirflag*/;   //alter rang (=grain duration + gap)							
	  midpointcount3=timecount;
	}
 if((timecount>((dur*3)/4))&&(constdensity==0))		//for mid to end point
	{ 
	 rang = gdur+(igmid3*gdur);
	 rang = (rang)+((gdur*(((timecount-midpointcount3)/(dur/4))*(igend-igmid3))))/*dirflag*/;
	} 
 if(constdensity==1)
	{
	 rang = gdur+(igstart*gdur);	   //calulate new total grain duration
	}
   
 
 if(gdchoice==1)
	{ 
	start=j;						 //each stream uses different grain duration so can all start at zero. 
	}
 if((gdchoice==2)||(gdchoice==3))
	{ 
	start=j+(rang*((i-1)/streams) ); //puts each stream equally out of phase 
	}
 iduration = rang*2;				//leave time at the end of each I statement for delay, reflections, etc..
 if(aval<0.0) {aval=aval+360.0;}
 if(aval>360.0) {aval=aval-360.0;} //keeps azimuth in the range 0-360
 temp2=rand();
 gfilepos=temp2/32767.0;
 fprintf(ofp, "i1\t %f\t %f\t %d\t %f\t %f\t %f\t %f\t %f\t %f\t %f\t %f\t %f\t %f\n", start, iduration, id, gphase, avalold, aval, evalold, eval, dvalold,dval,gdur,gfilepos,gspeed);
 index=index+(rang/mingraindur);	//increase index by multiples of minimum grain duration.
 avalold=aval;						//store old value for next pass
 evalold=eval;
 dvalold=dval;					
 timecount=timecount+rang;			//count the time elapsed 
}
 
fclose(ifpa);  
fclose(ifpe);  
fclose(ifpd);  
}
if(reverb==1)
{
 fprintf(ofp, "\ni99\t 0\t %f\t\n",dur);	//write I statement for global reverb instrument 99
}
fprintf(ofp, "\ne\n");

fclose(ofp);     
printf("\n\n\t\bScore file created and written to AmbiBoidgranule.sco\n\n");

}
